﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestingPosScale
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.ThreadException += new ThreadExceptionEventHandler(Application_ThreadException);
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

        static void Application_ThreadException(object sender, ThreadExceptionEventArgs e)
        {
            Logger.Log(Logger.Level.Fatal, "UNHANDLED THREAD EXCEPTION", e.Exception);
            MessageBox.Show($"An unhandled Thread Exception has occurred\nSee log file\n\n{e.Exception.Message}\n\nApplication will now exit", e.GetType().Name, MessageBoxButtons.OK, MessageBoxIcon.Error);
            Environment.Exit(1);
        }

        static void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
            Logger.Log(Logger.Level.Fatal, "UNHANDLED EXCEPTION", e.ExceptionObject as Exception);
            MessageBox.Show($"An unhandled Exception has occurred\n\nSee log file\n\n{(e.ExceptionObject as Exception).Message}\n\nApplication will now exit", e.GetType().Name, MessageBoxButtons.OK, MessageBoxIcon.Error);
            Environment.Exit(1);
        }
    }
}
